/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.45 Revision 1.118
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.45 2009/10/02 15:04:23 ayoy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.118 2012/02/09 22:58:36 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
15 13
14MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV}
16
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
16IUSE="${IUSE} debug pch" 21IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi
30
31DEPEND="dev-util/pkgconfig"
17RDEPEND=" 32RDEPEND="
18 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
19 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
20 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
21 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
22 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
23 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
24 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
25 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
26 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
27 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
28 !<x11-libs/qt-opengl-${PV} 47 !<x11-libs/qt-opengl-${PV}
29 !>x11-libs/qt-opengl-${PV}-r9999 48 !>x11-libs/qt-opengl-${PV}-r9999
30 !<x11-libs/qt-phonon-${PV} 49 !<x11-libs/qt-phonon-${PV}
31 !>x11-libs/qt-phonon-${PV}-r9999 50 !>x11-libs/qt-phonon-${PV}-r9999
32 !<x11-libs/qt-qt3support-${PV} 51 !<x11-libs/qt-qt3support-${PV}
42 !<x11-libs/qt-webkit-${PV} 61 !<x11-libs/qt-webkit-${PV}
43 !>x11-libs/qt-webkit-${PV}-r9999 62 !>x11-libs/qt-webkit-${PV}-r9999
44 !<x11-libs/qt-xmlpatterns-${PV} 63 !<x11-libs/qt-xmlpatterns-${PV}
45 !>x11-libs/qt-xmlpatterns-${PV}-r9999 64 !>x11-libs/qt-xmlpatterns-${PV}-r9999
46" 65"
47case "${PV}" in 66
48 4.?.?_rc*)
49 SRCTYPE="${SRCTYPE:-opensource-src}"
50 MY_PV="${PV/_rc/-rc}"
51 ;;
52 *)
53 SRCTYPE="${SRCTYPE:-opensource-src}"
54 MY_PV="${PV}"
55 ;;
56esac
57MY_P=qt-x11-${SRCTYPE}-${MY_PV}
58S=${WORKDIR}/${MY_P} 67S=${WORKDIR}/${MY_P}
59 68
60HOMEPAGE="http://qt.nokia.com/"
61SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
62if version_is_at_least 4.5.3 ${PV} ; then
63 SRC_URI="${SRC_URI/bz2/gz}"
64fi
65
66case "${PV}" in
67 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
68 *) ;;
69esac
70
71if version_is_at_least 4.5 ${PV} ; then
72 LICENSE="|| ( LGPL-2.1 GPL-3 )"
73fi
74
75# @FUNCTION: qt4-build_pkg_setup 69# @FUNCTION: qt4-build_pkg_setup
76# @DESCRIPTION: 70# @DESCRIPTION:
77# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 71# Sets up PATH and LD_LIBRARY_PATH.
78qt4-build_pkg_setup() { 72qt4-build_pkg_setup() {
79 # EAPI=2 ebuilds set use-deps, others need this: 73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
80 if [[ $EAPI != 2 ]]; then 74
81 # Make sure debug setting corresponds with qt-core (bug 258512) 75 # Protect users by not allowing downgrades between releases
82 if [[ $PN != "qt-core" ]]; then 76 # Downgrading revisions within the same release should be allowed
83 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 77 if has_version '>'${CATEGORY}/${P}-r9999; then
84 ~x11-libs/qt-core-${PV} debug" 78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
79 eerror "Sanity check to keep you from breaking your system:"
80 eerror " Downgrading Qt is completely unsupported and will break your system!"
81 die "aborting to save your system"
82 else
83 ewarn "Downgrading Qt is completely unsupported and will break your system!"
85 fi 84 fi
85 fi
86 86
87 # Check USE requirements 87 if [[ ${PN} == "qt-webkit" ]]; then
88 qt4-build_check_use 88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
89 fi 96 fi
97 eshopts_pop
98 fi
90 99
91 PATH="${S}/bin:${PATH}" 100 PATH="${S}/bin${PATH:+:}${PATH}"
101 if [[ ${CHOST} != *-darwin* ]]; then
92 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
103 else
104 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
105 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
106 # platform detection. Note: needs to come before any directories to
107 # avoid extract failure.
108 [[ ${CHOST} == *-apple-darwin* ]] && \
109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
110 ${QT4_EXTRACT_DIRECTORIES}"
111 fi
93 112
113 # Make sure ebuilds use the required EAPI
114 if [[ ${EAPI} != [234] ]]; then
115 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
116 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
117 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
118 die "qt4-build eclass requires EAPI 2,3 or 4"
119 fi
120
94 if ! version_is_at_least 4.1 $(gcc-version) ; then 121 if ! version_is_at_least 4.1 $(gcc-version); then
95 ewarn "Using a GCC version lower than 4.1 is not supported!" 122 ewarn "Using a GCC version lower than 4.1 is not supported!"
96 echo
97 ebeep 3
98 fi 123 fi
99} 124}
100 125
101# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
102# @DESCRIPTION: 127# @DESCRIPTION:
103# Arguments for build_target_directories. Takes the directories, in which the 128# Arguments for build_target_directories. Takes the directories in which the
104# code should be compiled. This is a space-separated list 129# code should be compiled. This is a space-separated list.
105 130
106# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
107# @DESCRIPTION: 132# @DESCRIPTION:
108# Space separated list including the directories that will be extracted from Qt 133# Space-separated list including the directories that will be extracted from
109# tarball 134# Qt tarball.
110 135
111# @FUNCTION: qt4-build_src_unpack 136# @FUNCTION: qt4-build_src_unpack
112# @DESCRIPTION: 137# @DESCRIPTION:
113# Unpacks the sources 138# Unpacks the sources.
114qt4-build_src_unpack() { 139qt4-build_src_unpack() {
115 setqtenv 140 setqtenv
116 local target targets licenses tar_pkg tar_args 141
117 if version_is_at_least 4.5 ${PV} ; then 142 local tarball="${MY_P}.tar.gz" target= targets=
118 licenses="LICENSE.GPL3 LICENSE.LGPL" 143 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
119 else
120 licenses="LICENSE.GPL2 LICENSE.GPL3"
121 fi
122 for target in configure ${licenses} projects.pro \
123 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 144 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
124 ${QT4_EXTRACT_DIRECTORIES}; do 145 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
146 do
125 targets="${targets} ${MY_P}/${target}" 147 targets+="${MY_P}/${target} "
126 done 148 done
127 149
128 tar_pkg=${MY_P}.tar.bz2 150 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
129 tar_args="xjpf" 151 tar -xzf "${DISTDIR}/${tarball}" ${targets}
130 if version_is_at_least 4.5.3 ${PV} ; then 152 eend $? || die "failed to unpack"
131 tar_pkg=${tar_pkg/bz2/gz}
132 tar_args="xzpf"
133 fi
134
135 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
136 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
137
138 case "${PV}" in
139 4.4.?)
140 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
141 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
142 ;;
143 esac
144
145 # Be backwards compatible for now
146 if [[ $EAPI != 2 ]]; then
147 qt4-build_src_prepare
148 fi
149} 153}
150 154
151# @ECLASS-VARIABLE: PATCHES 155# @ECLASS-VARIABLE: PATCHES
156# @DEFAULT_UNSET
152# @DESCRIPTION: 157# @DESCRIPTION:
153# In case you have patches to apply, specify them in PATCHES variable. Make sure 158# PATCHES array variable containing all various patches to be applied.
154# to specify the full path. This variable is necessary for src_prepare phase. 159# This variable is expected to be defined in global scope of ebuild.
155# example: 160# Make sure to specify the full path. This variable is utilised in
156# PATCHES="${FILESDIR}"/mypatch.patch 161# src_unpack/src_prepare phase, based on EAPI.
157# ${FILESDIR}"/mypatch2.patch"
158# 162#
163# @CODE
164# PATCHES=( "${FILESDIR}/mypatch.patch"
165# "${FILESDIR}/patches_folder/" )
166# @CODE
159 167
160# @FUNCTION: qt4-build_src_prepare 168# @FUNCTION: qt4-build_src_prepare
161# @DESCRIPTION: 169# @DESCRIPTION:
162# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 170# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
163# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 171# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
164qt4-build_src_prepare() { 172qt4-build_src_prepare() {
165 setqtenv 173 setqtenv
166 cd "${S}" 174 cd "${S}"
167 175
176 if version_is_at_least "4.7"; then
177 # fix libX11 dependency on non X packages
178 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
179 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
180
181 qt_assistant_cleanup
182 fi
183
184 if use aqua; then
185 # provide a proper macx-g++-64
186 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
187
188 sed -e '/^CONFIG/s:app_bundle::' \
189 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
190 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
191 fi
192
168 if [[ ${PN} != qt-core ]]; then 193 if [[ ${PN} != qt-core ]]; then
169 skip_qmake_build_patch 194 skip_qmake_build
170 skip_project_generation_patch 195 skip_project_generation
171 symlink_binaries_to_buildtree 196 symlink_binaries_to_buildtree
172 fi 197 fi
173 198
199 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
200 # qmake bus errors with -O2 but -O3 works
201 replace-flags -O2 -O3
202 fi
203
174 # Bug 178652 204 # Bug 178652
175 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 205 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
176 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
177 append-flags -fno-gcse 207 append-flags -fno-gcse
178 fi 208 fi
179 209
210 if use_if_iuse c++0x; then
211 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212 ewarn "this is an official standard, some of the reverse dependencies"
213 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215 ewarn "disabled."
216 append-flags -std=c++0x
217 fi
218
180 # Unsupported old gcc versions - hardened needs this :( 219 # Unsupported old gcc versions - hardened needs this :(
181 if [[ $(gcc-major-version) -lt "4" ]] ; then 220 if [[ $(gcc-major-version) -lt 4 ]] ; then
182 ewarn "Appending -fno-stack-protector to CXXFLAGS" 221 ewarn "Appending -fno-stack-protector to CXXFLAGS"
183 append-cxxflags -fno-stack-protector 222 append-cxxflags -fno-stack-protector
184 # Bug 253127 223 # Bug 253127
185 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
186 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 225 -i mkspecs/common/g++.conf || die
187 fi 226 fi
227
228 # Bug 261632
229 if use ppc64; then
230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
231 append-flags -mminimal-toc
232 fi
233
234 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
235 sed -e "/^SYSTEM_VARIABLES=/i \
236 CC='$(tc-getCC)'\n\
237 CXX='$(tc-getCXX)'\n\
238 CFLAGS='${CFLAGS}'\n\
239 CXXFLAGS='${CXXFLAGS}'\n\
240 LDFLAGS='${LDFLAGS}'\n" \
241 -i configure \
242 || die "sed SYSTEM_VARIABLES failed"
243
244 # Respect CC, CXX, LINK and *FLAGS in config.tests
245 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
246 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
247 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
248 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
249 || die "sed config.tests failed"
250
251 # Strip predefined CFLAGS from mkspecs (bug 312689)
252 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
188 253
189 # Bug 172219 254 # Bug 172219
255 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
256
257 if [[ ${CHOST} == *-darwin* ]]; then
258 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
259 # crippled (by design) :/
260 sed \
190 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 261 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
191 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 262 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
192 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 263 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
193 -e "s:X11R6/::" \ 264 -e "s:-arch\s\w*::g" \
194 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 265 -i mkspecs/common/mac-g++.conf \
266 || die "sed mkspecs/common/mac-g++.conf failed"
195 267
196 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 268 # Fix configure's -arch settings that appear in qmake/Makefile and also
197 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 269 # fix arch handling (automagically duplicates our -arch arg and breaks
198 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 270 # pch). Additionally disable Xarch support.
199 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 271 sed \
272 -e "s:-arch i386::" \
273 -e "s:-arch ppc::" \
274 -e "s:-arch x86_64::" \
275 -e "s:-arch ppc64::" \
276 -e "s:-arch \$i::" \
277 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
278 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
279 -e "s:-Xarch_x86_64::g" \
280 -e "s:-Xarch_ppc64::g" \
281 -i configure mkspecs/common/mac-g++.conf \
282 || die "sed -arch/-Xarch failed"
283
284 # On Snow Leopard don't fall back to 10.5 deployment target.
285 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
286 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
287 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
288 -i configure mkspecs/common/mac-g++.conf \
289 || die "sed deployment target failed"
290 fi
291 fi
292
293 # this one is needed for all systems with a separate -liconv, apart from
294 # Darwin, for which the sources already cater for -liconv
295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
296 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
297 -i config.tests/unix/iconv/iconv.pro \
298 || die "sed iconv.pro failed"
299 fi
300
301 # we need some patches for Solaris
302 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
303 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
304 # use GCC over SunStudio
305 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
306 # do not flirt with non-Prefix stuff, we're quite possessive
307 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
308 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
200 309
201 base_src_prepare 310 base_src_prepare
202} 311}
203 312
204# @FUNCTION: qt4-build_src_configure 313# @FUNCTION: qt4-build_src_configure
206# Default configure phase 315# Default configure phase
207qt4-build_src_configure() { 316qt4-build_src_configure() {
208 setqtenv 317 setqtenv
209 myconf="$(standard_configure_options) ${myconf}" 318 myconf="$(standard_configure_options) ${myconf}"
210 319
320 # this one is needed for all systems with a separate -liconv, apart from
321 # Darwin, for which the sources already cater for -liconv
322 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
323 myconf+=" -liconv"
324
325 if use_if_iuse glib; then
326 # use -I, -L and -l from configure
327 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
328 # avoid the -pthread argument
329 myconf+=" ${glibflags//-pthread}"
330 unset glibflags
331 fi
332
333 if use_if_iuse qpa; then
334 ewarn
335 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
336 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
337 ewarn "disable it before reporting any bugs related to this useflag."
338 ewarn
339 myconf+=" -qpa"
340 fi
341
342 if use aqua ; then
343 # On (snow) leopard use the new (frameworked) cocoa code.
344 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
345 myconf+=" -cocoa -framework"
346
347 # We are crazy and build cocoa + qt3support :-)
348 if use qt3support; then
349 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
350 -i configure || die
351 fi
352
353 # We need the source's headers, not the installed ones.
354 myconf+=" -I${S}/include"
355
356 # Add hint for the framework location.
357 myconf+=" -F${QTLIBDIR}"
358 fi
359 else
360 # freetype2 include dir is non-standard, thus include it on configure
361 # use -I from configure
362 myconf+=" $(pkg-config --cflags freetype2)"
363 fi
364
211 echo ./configure ${myconf} 365 echo ./configure ${myconf}
212 ./configure ${myconf} || die "./configure failed" 366 ./configure ${myconf} || die "./configure failed"
213 myconf="" 367 myconf=""
368
369 prepare_directories ${QT4_TARGET_DIRECTORIES}
214} 370}
215 371
216# @FUNCTION: qt4-build_src_compile 372# @FUNCTION: qt4-build_src_compile
373# @DESCRIPTION:
217# @DESCRIPTION: Actual compile phase 374# Actual compile phase
218qt4-build_src_compile() { 375qt4-build_src_compile() {
219 setqtenv 376 setqtenv
220 # Be backwards compatible for now
221 if [[ $EAPI != 2 ]]; then
222 qt4-build_src_configure
223 fi
224 377
225 build_directories "${QT4_TARGET_DIRECTORIES}" 378 build_directories ${QT4_TARGET_DIRECTORIES}
379}
380
381# @FUNCTION: qt4-build_src_test
382# @DESCRIPTION:
383# Runs tests only in target directories.
384qt4-build_src_test() {
385 # QtMultimedia does not have any test suite (bug #332299)
386 [[ ${PN} == "qt-multimedia" ]] && return
387
388 for dir in ${QT4_TARGET_DIRECTORIES}; do
389 emake -j1 check -C ${dir}
390 done
391}
392
393# @FUNCTION: fix_includes
394# @DESCRIPTION:
395# For MacOS X we need to add some symlinks when frameworks are
396# being used, to avoid complications with some more or less stupid packages.
397fix_includes() {
398 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
399 # Some packages tend to include <Qt/...>
400 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
401
402 # Fake normal headers when frameworks are installed... eases life later on
403 local dest f h
404 for frw in "${D}${QTLIBDIR}"/*.framework; do
405 [[ -e "${frw}"/Headers ]] || continue
406 f=$(basename ${frw})
407 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
408 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
409
410 # Link normal headers as well.
411 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
412 h=$(basename ${hdr})
413 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
414 done
415 done
416 fi
226} 417}
227 418
228# @FUNCTION: qt4-build_src_install 419# @FUNCTION: qt4-build_src_install
229# @DESCRIPTION: 420# @DESCRIPTION:
230# Perform the actual installation including some library fixes. 421# Perform the actual installation including some library fixes.
231qt4-build_src_install() { 422qt4-build_src_install() {
423 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
232 setqtenv 424 setqtenv
425
233 install_directories "${QT4_TARGET_DIRECTORIES}" 426 install_directories ${QT4_TARGET_DIRECTORIES}
234 install_qconfigs 427 install_qconfigs
235 fix_library_files 428 fix_library_files
429 fix_includes
430
431 # remove .la files since we are building only shared Qt libraries
432 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
236} 433}
237 434
238# @FUNCTION: setqtenv 435# @FUNCTION: setqtenv
436# @INTERNAL
239setqtenv() { 437setqtenv() {
240 # Set up installation directories 438 # Set up installation directories
241 QTBASEDIR=/usr/$(get_libdir)/qt4
242 QTPREFIXDIR=/usr 439 QTPREFIXDIR=${EPREFIX}/usr
243 QTBINDIR=/usr/bin 440 QTBINDIR=${EPREFIX}/usr/bin
244 QTLIBDIR=/usr/$(get_libdir)/qt4 441 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
245 QMAKE_LIBDIR_QT=${QTLIBDIR}
246 QTPCDIR=/usr/$(get_libdir)/pkgconfig 442 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
247 QTDATADIR=/usr/share/qt4
248 QTDOCDIR=/usr/share/doc/qt-${PV} 443 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
249 QTHEADERDIR=/usr/include/qt4 444 QTHEADERDIR=${EPREFIX}/usr/include/qt4
250 QTPLUGINDIR=${QTLIBDIR}/plugins 445 QTPLUGINDIR=${QTLIBDIR}/plugins
251 QTSYSCONFDIR=/etc/qt4 446 QTIMPORTDIR=${QTLIBDIR}/imports
447 QTDATADIR=${EPREFIX}/usr/share/qt4
252 QTTRANSDIR=${QTDATADIR}/translations 448 QTTRANSDIR=${QTDATADIR}/translations
449 QTSYSCONFDIR=${EPREFIX}/etc/qt4
253 QTEXAMPLESDIR=${QTDATADIR}/examples 450 QTEXAMPLESDIR=${QTDATADIR}/examples
254 QTDEMOSDIR=${QTDATADIR}/demos 451 QTDEMOSDIR=${QTDATADIR}/demos
452 QMAKE_LIBDIR_QT=${QTLIBDIR}
255 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4 453 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
454
256 PLATFORM=$(qt_mkspecs_dir) 455 PLATFORM=$(qt_mkspecs_dir)
257 456
258 unset QMAKESPEC 457 unset QMAKESPEC
259} 458}
260 459
261# @FUNCTION: standard_configure_options 460# @FUNCTION: standard_configure_options
461# @INTERNAL
262# @DESCRIPTION: 462# @DESCRIPTION:
263# Sets up some standard configure options, like libdir (if necessary), whether 463# Sets up some standard configure options, like libdir (if necessary), whether
264# debug info is wanted or not. 464# debug info is wanted or not.
265standard_configure_options() { 465standard_configure_options() {
266 local myconf="" 466 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
467 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
468 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
469 -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR} -sysconfdir ${QTSYSCONFDIR}
470 -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
471 -opensource -confirm-license -shared -fast -largefile -stl -verbose
472 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
267 473
268 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 474 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
269 475
270 # Disable visibility explicitly if gcc version isn't 4 476 # debug/release
271 if [[ "$(gcc-major-version)" -lt "4" ]]; then
272 myconf="${myconf} -no-reduce-exports"
273 fi
274
275 # precompiled headers doesn't work on hardened, where the flag is masked.
276 if use pch; then 477 if use debug; then
277 myconf="${myconf} -pch" 478 myconf+=" -debug"
278 else 479 else
279 myconf="${myconf} -no-pch" 480 myconf+=" -release"
280 fi 481 fi
281
282 if use debug; then
283 myconf="${myconf} -debug -no-separate-debug-info" 482 myconf+=" -no-separate-debug-info"
284 else 483
285 myconf="${myconf} -release -no-separate-debug-info" 484 # exceptions USE flag
286 fi 485 local exceptions="-exceptions"
486 in_iuse exceptions && exceptions="$(qt_use exceptions)"
487 myconf+=" ${exceptions}"
488
489 # disable RPATH on Qt >= 4.8 (bug 380415)
490 version_is_at_least 4.8 && myconf+=" -no-rpath"
491
492 # precompiled headers don't work on hardened, where the flag is masked
493 myconf+=" $(qt_use pch)"
494
495 # -reduce-relocations
496 # This flag seems to introduce major breakage to applications,
497 # mostly to be seen as a core dump with the message "QPixmap: Must
498 # construct a QApplication before a QPaintDevice" on Solaris.
499 # -- Daniel Vergien
500 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
501
502 use aqua && myconf+=" -no-framework"
287 503
288 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 504 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
289 # $(tc-arch). Therefore we convert it to supported values. 505 # $(tc-arch). Therefore we convert it to supported values.
290 case "$(tc-arch)" in 506 case "$(tc-arch)" in
291 amd64) myconf="${myconf} -arch x86_64" ;; 507 amd64|x64-*) myconf+=" -arch x86_64" ;;
508 ppc-macos) myconf+=" -arch ppc" ;;
292 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 509 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
510 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
511 x86-macos) myconf+=" -arch x86" ;;
293 x86|x86-*) myconf="${myconf} -arch i386" ;; 512 x86|x86-*) myconf+=" -arch i386" ;;
294 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 513 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
295 hppa|sh) myconf="${myconf} -arch generic" ;; 514 hppa|sh) myconf+=" -arch generic" ;;
296 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 515 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
297 esac 516 esac
298 517
299 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license -no-rpath
300 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
301 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
302 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
303 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
304 -demosdir ${QTDEMOSDIR} -silent -fast
305 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
306 -reduce-relocations -nomake examples -nomake demos"
307
308 # Make eclass 4.5.{1,2} ready
309 case "${MY_PV}" in
310 4.5.1 | 4.5.2)
311 myconf="${myconf} -opensource"
312 ;;
313 esac
314
315 echo "${myconf}" 518 echo "${myconf}"
316} 519}
520
521# @FUNCTION: prepare_directories
522# @USAGE: < directories >
523# @INTERNAL
524# @DESCRIPTION:
525# Generates Makefiles for the given list of directories.
526prepare_directories() {
527 for x in "$@"; do
528 pushd "${S}"/${x} >/dev/null || die
529 einfo "Running qmake in: ${x}"
530 # avoid running over the maximum argument number, bug #299810
531 {
532 echo "${S}"/mkspecs/common/*.conf
533 find "${S}" -name '*.pr[io]'
534 } | xargs sed -i \
535 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
536 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
537 || die
538 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
539 popd >/dev/null || die
540 done
541}
542
317 543
318# @FUNCTION: build_directories 544# @FUNCTION: build_directories
319# @USAGE: < directories > 545# @USAGE: < directories >
546# @INTERNAL
320# @DESCRIPTION: 547# @DESCRIPTION:
321# Compiles the code in $QT4_TARGET_DIRECTORIES 548# Compiles the code in the given list of directories.
322build_directories() { 549build_directories() {
323 local dirs="$@"
324 for x in ${dirs}; do 550 for x in "$@"; do
325 cd "${S}"/${x} 551 pushd "${S}"/${x} >/dev/null || die
326 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 552 emake CC="$(tc-getCC)" \
327 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 553 CXX="$(tc-getCXX)" \
328 emake || die "emake failed" 554 LINK="$(tc-getCXX)" || die "emake failed"
555 popd >/dev/null || die
329 done 556 done
330} 557}
331 558
332# @FUNCTION: install_directories 559# @FUNCTION: install_directories
333# @USAGE: < directories > 560# @USAGE: < directories >
561# @INTERNAL
334# @DESCRIPTION: 562# @DESCRIPTION:
335# run emake install in the given directories, which are separated by spaces 563# Runs emake install in the given directories, which are separated by spaces.
336install_directories() { 564install_directories() {
337 local dirs="$@"
338 for x in ${dirs}; do 565 for x in "$@"; do
339 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 566 pushd "${S}"/${x} >/dev/null || die
340 emake INSTALL_ROOT="${D}" install || die "emake install failed" 567 emake INSTALL_ROOT="${D}" install || die "emake install failed"
341 popd >/dev/null || die "Can't popd from ${S}/${x}" 568 popd >/dev/null || die
342 done 569 done
343} 570}
344 571
345# @ECLASS-VARIABLE: QCONFIG_ADD 572# @ECLASS-VARIABLE: QCONFIG_ADD
346# @DESCRIPTION: 573# @DESCRIPTION:
347# List options that need to be added to QT_CONFIG in qconfig.pri 574# List options that need to be added to QT_CONFIG in qconfig.pri
348QCONFIG_ADD="${QCONFIG_ADD:-}" 575: ${QCONFIG_ADD:=}
349 576
350# @ECLASS-VARIABLE: QCONFIG_REMOVE 577# @ECLASS-VARIABLE: QCONFIG_REMOVE
351# @DESCRIPTION: 578# @DESCRIPTION:
352# List options that need to be removed from QT_CONFIG in qconfig.pri 579# List options that need to be removed from QT_CONFIG in qconfig.pri
353QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 580: ${QCONFIG_REMOVE:=}
354 581
355# @ECLASS-VARIABLE: QCONFIG_DEFINE 582# @ECLASS-VARIABLE: QCONFIG_DEFINE
356# @DESCRIPTION: 583# @DESCRIPTION:
357# List variables that should be defined at the top of QtCore/qconfig.h 584# List variables that should be defined at the top of QtCore/qconfig.h
358QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 585: ${QCONFIG_DEFINE:=}
359 586
360# @FUNCTION: install_qconfigs 587# @FUNCTION: install_qconfigs
588# @INTERNAL
589# @DESCRIPTION:
361# @DESCRIPTION: Install gentoo-specific mkspecs configurations 590# Install gentoo-specific mkspecs configurations.
362install_qconfigs() { 591install_qconfigs() {
363 local x 592 local x
364 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 593 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
365 for x in QCONFIG_ADD QCONFIG_REMOVE; do 594 for x in QCONFIG_ADD QCONFIG_REMOVE; do
366 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 595 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
367 done 596 done
368 insinto ${QTDATADIR}/mkspecs/gentoo 597 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
369 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 598 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
370 fi 599 fi
371 600
372 if [[ -n ${QCONFIG_DEFINE} ]]; then 601 if [[ -n ${QCONFIG_DEFINE} ]]; then
373 for x in ${QCONFIG_DEFINE}; do 602 for x in ${QCONFIG_DEFINE}; do
374 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 603 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
375 done 604 done
376 insinto ${QTHEADERDIR}/Gentoo 605 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
377 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 606 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
378 fi 607 fi
379} 608}
380 609
381# @FUNCTION: generate_qconfigs 610# @FUNCTION: generate_qconfigs
382# @DESCRIPTION: Generates gentoo-specific configurations 611# @INTERNAL
612# @DESCRIPTION:
613# Generates gentoo-specific qconfig.{h,pri}.
383generate_qconfigs() { 614generate_qconfigs() {
384 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 615 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
385 local x qconfig_add qconfig_remove qconfig_new 616 local x qconfig_add qconfig_remove qconfig_new
386 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 617 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
387 [[ -f ${x} ]] || continue 618 [[ -f ${x} ]] || continue
388 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 619 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
389 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 620 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
390 done 621 done
391 622
392 # these error checks do not use die because dying in pkg_post{inst,rm} 623 # these error checks do not use die because dying in pkg_post{inst,rm}
393 # just makes things worse. 624 # just makes things worse.
394 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 625 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
401 632
402 # generate list of QT_CONFIG entries from the existing list 633 # generate list of QT_CONFIG entries from the existing list
403 # including qconfig_add and excluding qconfig_remove 634 # including qconfig_add and excluding qconfig_remove
404 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 635 for x in $(sed -n 's/^QT_CONFIG +=//p' \
405 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 636 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
406 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 637 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
407 done 638 done
408 639
409 # replace the existing QT_CONFIG list with qconfig_new 640 # replace the existing QT_CONFIG list with qconfig_new
410 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 641 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
411 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 642 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
435 fi 666 fi
436 fi 667 fi
437} 668}
438 669
439# @FUNCTION: qt4-build_pkg_postrm 670# @FUNCTION: qt4-build_pkg_postrm
671# @DESCRIPTION:
440# @DESCRIPTION: Generate configurations when the package is completely removed 672# Regenerate configuration when the package is completely removed.
441qt4-build_pkg_postrm() { 673qt4-build_pkg_postrm() {
442 generate_qconfigs 674 generate_qconfigs
443} 675}
444 676
445# @FUNCTION: qt4-build_pkg_postinst 677# @FUNCTION: qt4-build_pkg_postinst
678# @DESCRIPTION:
446# @DESCRIPTION: Generate configuration, plus throws a message about possible 679# Regenerate configuration, plus throw a message about possible
447# breakages and proposed solutions. 680# breakages and proposed solutions.
448qt4-build_pkg_postinst() { 681qt4-build_pkg_postinst() {
449 generate_qconfigs 682 generate_qconfigs
450 echo
451 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
452 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
453 ewarn "should recompile the packages providing these plugins. Also, make sure you"
454 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
455 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
456 ewarn
457 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
458 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
459 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
460 ewarn "configuration."
461 ewarn
462 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
463 echo
464} 683}
465 684
466# @FUNCTION: skip_qmake_build_patch 685# @FUNCTION: skip_qmake_build
686# @INTERNAL
467# @DESCRIPTION: 687# @DESCRIPTION:
468# Don't need to build qmake, as it's already installed from qt-core 688# Patches configure to skip qmake compilation, as it's already installed by qt-core.
469skip_qmake_build_patch() { 689skip_qmake_build() {
470 # Don't need to build qmake, as it's already installed from qt-core
471 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 690 sed -i -e "s:if true:if false:g" "${S}"/configure || die
472} 691}
473 692
474# @FUNCTION: skip_project_generation_patch 693# @FUNCTION: skip_project_generation
694# @INTERNAL
475# @DESCRIPTION: 695# @DESCRIPTION:
476# Exit the script early by throwing in an exit before all of the .pro files are scanned 696# Exit the script early by throwing in an exit before all of the .pro files are scanned.
477skip_project_generation_patch() { 697skip_project_generation() {
478 # Exit the script early by throwing in an exit before all of the .pro files are scanned
479 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 698 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
480 -i "${S}"/configure || die "Sed failed"
481} 699}
482 700
483# @FUNCTION: symlink_binaries_to_buildtree 701# @FUNCTION: symlink_binaries_to_buildtree
702# @INTERNAL
484# @DESCRIPTION: 703# @DESCRIPTION:
485# Symlink generated binaries to buildtree so they can be used during compilation 704# Symlinks generated binaries to buildtree, so they can be used during compilation time.
486# time
487symlink_binaries_to_buildtree() { 705symlink_binaries_to_buildtree() {
488 for bin in qmake moc uic rcc; do 706 for bin in qmake moc uic rcc; do
489 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 707 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
490 done 708 done
491} 709}
492 710
493# @FUNCTION: fix_library_files 711# @FUNCTION: fix_library_files
712# @INTERNAL
494# @DESCRIPTION: 713# @DESCRIPTION:
495# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 714# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
496# moves the *.pc-files into the pkgconfig directory 715# moves the *.pc files into the pkgconfig directory.
497fix_library_files() { 716fix_library_files() {
717 local libfile
498 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 718 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
499 if [[ -e ${libfile} ]]; then 719 if [[ -e ${libfile} ]]; then
500 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 720 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
501 fi 721 fi
502 done 722 done
503 723
504 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 724 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
505 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 725 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
506 if [[ -e ${libfile} ]]; then 726 if [[ -e ${libfile} ]]; then
507 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 727 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
508 728
509 # Move .pc files into the pkgconfig directory 729 # Move .pc files into the pkgconfig directory
510 dodir ${QTPCDIR} 730 dodir ${QTPCDIR#${EPREFIX}}
511 mv ${libfile} "${D}"/${QTPCDIR}/ \ 731 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
512 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
513 fi 732 fi
514 done 733 done
515 734
516 # Don't install an empty directory 735 # Don't install an empty directory
517 rmdir "${D}"/${QTLIBDIR}/pkgconfig 736 rmdir "${D}"/${QTLIBDIR}/pkgconfig
518} 737}
519 738
520# @FUNCTION: qt_use 739# @FUNCTION: qt_use
521# @USAGE: < flag > [ feature ] [ enableval ] 740# @USAGE: < flag > [ feature ] [ enableval ]
522# @DESCRIPTION: 741# @DESCRIPTION:
523# This will echo "${enableval}-${feature}" if <flag> is enabled, or 742# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
524# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 743# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
525# will be used for that. If [enableval] is not specified, it omits the 744# will be used for that. If [enableval] is not specified, it omits the
526# assignment-part 745# "-${enableval}" part.
527qt_use() { 746qt_use() {
528 local flag="${1}" 747 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
529 local feature="${1}"
530 local enableval=
531
532 [[ -n ${2} ]] && feature=${2}
533 [[ -n ${3} ]] && enableval="-${3}"
534
535 if use ${flag}; then
536 echo "${enableval}-${feature}"
537 else
538 echo "-no-${feature}"
539 fi
540}
541
542# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
543# @DESCRIPTION:
544# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
545# (eutils.eclass), line per line.
546#
547# Example:
548# @CODE
549# pkg_setup() {
550# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
551# ~x11-libs/qt-gui-${PV} qt3support"
552# qt4-build_check_use
553# }
554# @CODE
555
556# Run built_with_use on each flag and print appropriate error messages if any
557# flags are missing
558
559_qt_built_with_use() {
560 local missing opt pkg flag flags
561
562 if [[ ${1} = "--missing" ]]; then
563 missing="${1} ${2}" && shift 2
564 fi
565 if [[ ${1:0:1} = "-" ]]; then
566 opt=${1} && shift
567 fi
568
569 pkg=${1} && shift
570
571 for flag in "${@}"; do
572 flags="${flags} ${flag}"
573 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
574 flags="${flags}*"
575 else
576 [[ ${opt} = "-o" ]] && return 0
577 fi
578 done
579 if [[ "${flags# }" = "${@}" ]]; then
580 return 0
581 fi
582 if [[ ${opt} = "-o" ]]; then
583 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
584 else
585 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
586 fi
587 return 1
588}
589
590# @FUNCTION: qt4-build_check_use
591# @DESCRIPTION:
592# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
593# USE flags listed.
594#
595# If any of the required USE flags are missing, an eerror will be printed for
596# each package with missing USE flags.
597qt4-build_check_use() {
598 local line missing
599 while read line; do
600 [[ -z ${line} ]] && continue
601 if ! _qt_built_with_use ${line}; then
602 missing=true
603 fi
604 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
605 if [[ -n ${missing} ]]; then
606 echo
607 eerror "Flags marked with an * are missing."
608 die "Missing USE flags found"
609 fi
610} 748}
611 749
612# @FUNCTION: qt_mkspecs_dir 750# @FUNCTION: qt_mkspecs_dir
613# @RETURN: the specs-directory w/o path 751# @RETURN: the specs-directory w/o path
614# @DESCRIPTION: 752# @DESCRIPTION:
615# Allows us to define which mkspecs dir we want to use. 753# Allows us to define which mkspecs dir we want to use.
616qt_mkspecs_dir() { 754qt_mkspecs_dir() {
617 # Allows us to define which mkspecs dir we want to use.
618 local spec 755 local spec=
619
620 case ${CHOST} in 756 case ${CHOST} in
621 *-freebsd*|*-dragonfly*) 757 *-freebsd*|*-dragonfly*)
622 spec="freebsd" ;; 758 spec=freebsd ;;
623 *-openbsd*) 759 *-openbsd*)
624 spec="openbsd" ;; 760 spec=openbsd ;;
625 *-netbsd*) 761 *-netbsd*)
626 spec="netbsd" ;; 762 spec=netbsd ;;
627 *-darwin*) 763 *-darwin*)
764 if use aqua; then
765 # mac with carbon/cocoa
766 spec=macx
767 else
768 # darwin/mac with x11
628 spec="darwin" ;; 769 spec=darwin
770 fi
771 ;;
772 *-solaris*)
773 spec=solaris ;;
629 *-linux-*|*-linux) 774 *-linux-*|*-linux)
630 spec="linux" ;; 775 spec=linux ;;
631 *) 776 *)
632 die "Unknown CHOST, no platform choosen." 777 die "Unknown CHOST, no platform chosen"
633 esac 778 esac
634 779
635 CXX=$(tc-getCXX) 780 CXX=$(tc-getCXX)
636 if [[ ${CXX/g++/} != ${CXX} ]]; then 781 if [[ ${CXX} == *g++* ]]; then
637 spec="${spec}-g++" 782 spec+=-g++
638 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 783 elif [[ ${CXX} == *icpc* ]]; then
639 spec="${spec}-icc" 784 spec+=-icc
640 else 785 else
641 die "Unknown compiler ${CXX}." 786 die "Unknown compiler '${CXX}'"
642 fi 787 fi
643 if [[ -n "${LIBDIR/lib}" ]]; then 788
644 spec="${spec}-${LIBDIR/lib}" 789 # Add -64 for 64bit profiles
790 if use x64-freebsd ||
791 use amd64-linux ||
792 use x64-macos ||
793 use x64-solaris ||
794 use sparc64-solaris
795 then
796 spec+=-64
645 fi 797 fi
646 798
647 echo "${spec}" 799 echo "${spec}"
648} 800}
649 801
650case ${EAPI:-0} in 802# @FUNCTION: qt_assistant_cleanup
651 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 803# @INTERNAL
804# @DESCRIPTION:
805# Tries to clean up tools.pro for qt-assistant ebuilds.
806# Meant to be called in src_prepare().
807# Since Qt 4.7.4 this function is a no-op.
808qt_assistant_cleanup() {
809 # apply patching to qt-assistant ebuilds only
810 [[ ${PN} != "qt-assistant" ]] && return
811
812 # no longer needed for 4.7.4 and later
813 version_is_at_least "4.7.4" && return
814
815 # different versions (and branches...) may need different handling,
816 # add a case if you need special handling
817 case "${MY_PV_EXTRA}" in
818 *kde-qt*)
819 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
820 -e "/mac/,/^embedded.*makeqpf$/d" \
821 -i tools/tools.pro || die "patching tools.pro failed"
822 ;;
823 *)
824 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
825 -e "/mac/,/^embedded.*makeqpf$/d" \
826 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
827 -i tools/tools.pro || die "patching tools.pro failed"
828 ;;
829 esac
830}
831
832# @FUNCTION: qt_nolibx11
833# @INTERNAL
834# @DESCRIPTION:
835# Ignore X11 tests for packages that don't need X libraries installed.
836qt_nolibx11() {
837 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
838 die "x11 check sed failed"
839}
840
652 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 841EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
653esac

Legend:
Removed from v.1.45  
changed lines
  Added in v.1.118

  ViewVC Help
Powered by ViewVC 1.1.20